# coding: utf-8

"""
    Fortanix SDKMS REST API

    This is a set of REST APIs for accessing the Fortanix Self-Defending Key Management System. This includes APIs for managing accounts, and for performing cryptographic and key management operations. 

    OpenAPI spec version: 1.0.0-20200608
    Contact: support@fortanix.com
    Generated by: https://github.com/swagger-api/swagger-codegen.git

    Licensed under the Apache License, Version 2.0 (the "License");
    you may not use this file except in compliance with the License.
    You may obtain a copy of the License at
    
        http://www.apache.org/licenses/LICENSE-2.0
    
    Unless required by applicable law or agreed to in writing, software
    distributed under the License is distributed on an "AS IS" BASIS,
    WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
    See the License for the specific language governing permissions and
    limitations under the License.
"""


from pprint import pformat
from six import iteritems
import re




# NOTE: This class is auto generated by the swagger code generator program.
# Do not edit the class manually.
class ApprovalSubject(object):
    """
    @undocumented: swagger_types
    @undocumented: attribute_map
    @undocumented: to_dict
    @undocumented: to_str
    @undocumented: __repr__
    @undocumented: __eq__
    @undocumented: __ne__
    """

    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'group': 'str',
        'sobject': 'str',
        'app': 'str',
        'plugin': 'str'
    }

    attribute_map = {
        'group': 'group',
        'sobject': 'sobject',
        'app': 'app',
        'plugin': 'plugin'
    }

    def __init__(self, group=None, sobject=None, app=None, plugin=None):
        """
        ApprovalSubject - a model defined in Swagger
        """

        self._group = None
        self._sobject = None
        self._app = None
        self._plugin = None

        if group is not None:
          self.group = group
        if sobject is not None:
          self.sobject = sobject
        if app is not None:
          self.app = app
        if plugin is not None:
          self.plugin = plugin

    @property
    def group(self):
        """
        Gets the group of this ApprovalSubject.
        The ID of the group being acted upon, if the subject is a group.

        Type: L{str}
        """
        return self._group

    @group.setter
    def group(self, group):
        """
        Sets the group of this ApprovalSubject.
        The ID of the group being acted upon, if the subject is a group.
        """

        self._group = group

    @property
    def sobject(self):
        """
        Gets the sobject of this ApprovalSubject.
        The ID of the security object being acted upon, if the subject is a security object.

        Type: L{str}
        """
        return self._sobject

    @sobject.setter
    def sobject(self, sobject):
        """
        Sets the sobject of this ApprovalSubject.
        The ID of the security object being acted upon, if the subject is a security object.
        """

        self._sobject = sobject

    @property
    def app(self):
        """
        Gets the app of this ApprovalSubject.
        The ID of the app being acted upon, if the subject is a app.

        Type: L{str}
        """
        return self._app

    @app.setter
    def app(self, app):
        """
        Sets the app of this ApprovalSubject.
        The ID of the app being acted upon, if the subject is a app.
        """

        self._app = app

    @property
    def plugin(self):
        """
        Gets the plugin of this ApprovalSubject.
        The ID of the plugin being acted upon, if the subject is a app.

        Type: L{str}
        """
        return self._plugin

    @plugin.setter
    def plugin(self, plugin):
        """
        Sets the plugin of this ApprovalSubject.
        The ID of the plugin being acted upon, if the subject is a app.
        """

        self._plugin = plugin

    def to_dict(self):
        """
        Returns the model properties as a dict
        """
        result = {}

        for attr, _ in iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """
        Returns the string representation of the model
        """
        return pformat(self.to_dict())

    def __repr__(self):
        """
        For `print` and `pprint`
        """
        return self.to_str()

    def __eq__(self, other):
        """
        Returns true if both objects are equal
        """
        if not isinstance(other, ApprovalSubject):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """
        Returns true if both objects are not equal
        """
        return not self == other

