# coding: utf-8

"""
    Fortanix SDKMS REST API

    This is a set of REST APIs for accessing the Fortanix Self-Defending Key Management System. This includes APIs for managing accounts, and for performing cryptographic and key management operations. 

    OpenAPI spec version: 1.0.0-20200608
    Contact: support@fortanix.com
    Generated by: https://github.com/swagger-api/swagger-codegen.git

    Licensed under the Apache License, Version 2.0 (the "License");
    you may not use this file except in compliance with the License.
    You may obtain a copy of the License at
    
        http://www.apache.org/licenses/LICENSE-2.0
    
    Unless required by applicable law or agreed to in writing, software
    distributed under the License is distributed on an "AS IS" BASIS,
    WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
    See the License for the specific language governing permissions and
    limitations under the License.
"""


from pprint import pformat
from six import iteritems
import re




# NOTE: This class is auto generated by the swagger code generator program.
# Do not edit the class manually.
class AuthConfig(object):
    """
    @undocumented: swagger_types
    @undocumented: attribute_map
    @undocumented: to_dict
    @undocumented: to_str
    @undocumented: __repr__
    @undocumented: __eq__
    @undocumented: __ne__
    """

    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'password': 'AuthConfigPassword',
        'saml': 'str',
        'signed_jwt': 'AuthConfigSignedJWT'
    }

    attribute_map = {
        'password': 'password',
        'saml': 'saml',
        'signed_jwt': 'signed_jwt'
    }

    def __init__(self, password=None, saml=None, signed_jwt=None):
        """
        AuthConfig - a model defined in Swagger
        """

        self._password = None
        self._saml = None
        self._signed_jwt = None

        if password is not None:
          self.password = password
        if saml is not None:
          self.saml = saml
        if signed_jwt is not None:
          self.signed_jwt = signed_jwt

    @property
    def password(self):
        """
        Gets the password of this AuthConfig.

        Type: L{AuthConfigPassword}
        """
        return self._password

    @password.setter
    def password(self, password):
        """
        Sets the password of this AuthConfig.
        """

        self._password = password

    @property
    def saml(self):
        """
        Gets the saml of this AuthConfig.
        XML metadata for a SAML 2.0 Identity Provider (IdP).

        Type: L{str}
        """
        return self._saml

    @saml.setter
    def saml(self, saml):
        """
        Sets the saml of this AuthConfig.
        XML metadata for a SAML 2.0 Identity Provider (IdP).
        """

        self._saml = saml

    @property
    def signed_jwt(self):
        """
        Gets the signed_jwt of this AuthConfig.
        Signed JWT verification data

        Type: L{AuthConfigSignedJWT}
        """
        return self._signed_jwt

    @signed_jwt.setter
    def signed_jwt(self, signed_jwt):
        """
        Sets the signed_jwt of this AuthConfig.
        Signed JWT verification data
        """

        self._signed_jwt = signed_jwt

    def to_dict(self):
        """
        Returns the model properties as a dict
        """
        result = {}

        for attr, _ in iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """
        Returns the string representation of the model
        """
        return pformat(self.to_dict())

    def __repr__(self):
        """
        For `print` and `pprint`
        """
        return self.to_str()

    def __eq__(self, other):
        """
        Returns true if both objects are equal
        """
        if not isinstance(other, AuthConfig):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """
        Returns true if both objects are not equal
        """
        return not self == other

