# coding: utf-8

"""
    Fortanix SDKMS REST API

    This is a set of REST APIs for accessing the Fortanix Self-Defending Key Management System. This includes APIs for managing accounts, and for performing cryptographic and key management operations. 

    OpenAPI spec version: 1.0.0-20200608
    Contact: support@fortanix.com
    Generated by: https://github.com/swagger-api/swagger-codegen.git

    Licensed under the Apache License, Version 2.0 (the "License");
    you may not use this file except in compliance with the License.
    You may obtain a copy of the License at
    
        http://www.apache.org/licenses/LICENSE-2.0
    
    Unless required by applicable law or agreed to in writing, software
    distributed under the License is distributed on an "AS IS" BASIS,
    WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
    See the License for the specific language governing permissions and
    limitations under the License.
"""


from pprint import pformat
from six import iteritems
import re




# NOTE: This class is auto generated by the swagger code generator program.
# Do not edit the class manually.
class FpeOptionsAdvanced(object):
    """
    @undocumented: swagger_types
    @undocumented: attribute_map
    @undocumented: to_dict
    @undocumented: to_str
    @undocumented: __repr__
    @undocumented: __eq__
    @undocumented: __ne__
    """

    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'format': 'FpeDataPart',
        'description': 'str',
        'name': 'str'
    }

    attribute_map = {
        'format': 'format',
        'description': 'description',
        'name': 'name'
    }

    def __init__(self, format=None, description=None, name=None):
        """
        FpeOptionsAdvanced - a model defined in Swagger
        """

        self._format = None
        self._description = None
        self._name = None

        self.format = format
        if description is not None:
          self.description = description
        if name is not None:
          self.name = name

    @property
    def format(self):
        """
        Gets the format of this FpeOptionsAdvanced.

        Type: L{FpeDataPart}
        """
        return self._format

    @format.setter
    def format(self, format):
        """
        Sets the format of this FpeOptionsAdvanced.
        """

        self._format = format

    @property
    def description(self):
        """
        Gets the description of this FpeOptionsAdvanced.
        The user-friendly name for the data type that represents the input data.

        Type: L{str}
        """
        return self._description

    @description.setter
    def description(self, description):
        """
        Sets the description of this FpeOptionsAdvanced.
        The user-friendly name for the data type that represents the input data.
        """

        self._description = description

    @property
    def name(self):
        """
        Gets the name of this FpeOptionsAdvanced.
        A duplicate of the `description` field. This field is read-only and cannot be assigned. Thus, when specifying a new `SobjectRequest`, this field should not be used. 

        Type: L{str}
        """
        return self._name

    @name.setter
    def name(self, name):
        """
        Sets the name of this FpeOptionsAdvanced.
        A duplicate of the `description` field. This field is read-only and cannot be assigned. Thus, when specifying a new `SobjectRequest`, this field should not be used. 
        """

        self._name = name

    def to_dict(self):
        """
        Returns the model properties as a dict
        """
        result = {}

        for attr, _ in iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """
        Returns the string representation of the model
        """
        return pformat(self.to_dict())

    def __repr__(self):
        """
        For `print` and `pprint`
        """
        return self.to_str()

    def __eq__(self, other):
        """
        Returns true if both objects are equal
        """
        if not isinstance(other, FpeOptionsAdvanced):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """
        Returns true if both objects are not equal
        """
        return not self == other

