# coding: utf-8

"""
    Fortanix SDKMS REST API

    This is a set of REST APIs for accessing the Fortanix Self-Defending Key Management System. This includes APIs for managing accounts, and for performing cryptographic and key management operations. 

    OpenAPI spec version: 1.0.0-20200608
    Contact: support@fortanix.com
    Generated by: https://github.com/swagger-api/swagger-codegen.git

    Licensed under the Apache License, Version 2.0 (the "License");
    you may not use this file except in compliance with the License.
    You may obtain a copy of the License at
    
        http://www.apache.org/licenses/LICENSE-2.0
    
    Unless required by applicable law or agreed to in writing, software
    distributed under the License is distributed on an "AS IS" BASIS,
    WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
    See the License for the specific language governing permissions and
    limitations under the License.
"""


from pprint import pformat
from six import iteritems
import re




# NOTE: This class is auto generated by the swagger code generator program.
# Do not edit the class manually.
class HistoryItem(object):
    """
    @undocumented: swagger_types
    @undocumented: attribute_map
    @undocumented: to_dict
    @undocumented: to_str
    @undocumented: __repr__
    @undocumented: __eq__
    @undocumented: __ne__
    """

    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'id': 'str',
        'state': 'HistoryItemState',
        'created_at': 'str',
        'expiry': 'str'
    }

    attribute_map = {
        'id': 'id',
        'state': 'state',
        'created_at': 'created_at',
        'expiry': 'expiry'
    }

    def __init__(self, id=None, state=None, created_at=None, expiry=None):
        """
        HistoryItem - a model defined in Swagger
        """

        self._id = None
        self._state = None
        self._created_at = None
        self._expiry = None

        if id is not None:
          self.id = id
        if state is not None:
          self.state = state
        if created_at is not None:
          self.created_at = created_at
        if expiry is not None:
          self.expiry = expiry

    @property
    def id(self):
        """
        Gets the id of this HistoryItem.
        History item ID uniquely identifying this history item

        Type: L{str}
        """
        return self._id

    @id.setter
    def id(self, id):
        """
        Sets the id of this HistoryItem.
        History item ID uniquely identifying this history item
        """

        self._id = id

    @property
    def state(self):
        """
        Gets the state of this HistoryItem.

        Type: L{HistoryItemState}
        """
        return self._state

    @state.setter
    def state(self, state):
        """
        Sets the state of this HistoryItem.
        """

        self._state = state

    @property
    def created_at(self):
        """
        Gets the created_at of this HistoryItem.
        Date and time this history item was created

        Type: L{str}
        """
        return self._created_at

    @created_at.setter
    def created_at(self, created_at):
        """
        Sets the created_at of this HistoryItem.
        Date and time this history item was created
        """

        self._created_at = created_at

    @property
    def expiry(self):
        """
        Gets the expiry of this HistoryItem.
        Date and time this history item will expire. KeyObjects cannot be reverted to expired history items.

        Type: L{str}
        """
        return self._expiry

    @expiry.setter
    def expiry(self, expiry):
        """
        Sets the expiry of this HistoryItem.
        Date and time this history item will expire. KeyObjects cannot be reverted to expired history items.
        """

        self._expiry = expiry

    def to_dict(self):
        """
        Returns the model properties as a dict
        """
        result = {}

        for attr, _ in iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """
        Returns the string representation of the model
        """
        return pformat(self.to_dict())

    def __repr__(self):
        """
        For `print` and `pprint`
        """
        return self.to_str()

    def __eq__(self, other):
        """
        Returns true if both objects are equal
        """
        if not isinstance(other, HistoryItem):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """
        Returns true if both objects are not equal
        """
        return not self == other

