# coding: utf-8

"""
    Fortanix SDKMS REST API

    This is a set of REST APIs for accessing the Fortanix Self-Defending Key Management System. This includes APIs for managing accounts, and for performing cryptographic and key management operations. 

    OpenAPI spec version: 1.0.0-20200608
    Contact: support@fortanix.com
    Generated by: https://github.com/swagger-api/swagger-codegen.git

    Licensed under the Apache License, Version 2.0 (the "License");
    you may not use this file except in compliance with the License.
    You may obtain a copy of the License at
    
        http://www.apache.org/licenses/LICENSE-2.0
    
    Unless required by applicable law or agreed to in writing, software
    distributed under the License is distributed on an "AS IS" BASIS,
    WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
    See the License for the specific language governing permissions and
    limitations under the License.
"""


from pprint import pformat
from six import iteritems
import re




# NOTE: This class is auto generated by the swagger code generator program.
# Do not edit the class manually.
class MacVerifyRequest(object):
    """
    @undocumented: swagger_types
    @undocumented: attribute_map
    @undocumented: to_dict
    @undocumented: to_str
    @undocumented: __repr__
    @undocumented: __eq__
    @undocumented: __ne__
    """

    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'alg': 'DigestAlgorithm',
        'data': 'bytearray',
        'digest': 'bytearray',
        'mac': 'bytearray'
    }

    attribute_map = {
        'alg': 'alg',
        'data': 'data',
        'digest': 'digest',
        'mac': 'mac'
    }

    def __init__(self, alg=None, data=None, digest=None, mac=None):
        """
        MacVerifyRequest - a model defined in Swagger
        """

        self._alg = None
        self._data = None
        self._digest = None
        self._mac = None

        self.alg = alg
        self.data = data
        if digest is not None:
          self.digest = digest
        if mac is not None:
          self.mac = mac

    @property
    def alg(self):
        """
        Gets the alg of this MacVerifyRequest.

        Type: L{DigestAlgorithm}
        """
        return self._alg

    @alg.setter
    def alg(self, alg):
        """
        Sets the alg of this MacVerifyRequest.
        """

        self._alg = alg

    @property
    def data(self):
        """
        Gets the data of this MacVerifyRequest.
        The data to verify the MAC of.

        Type: L{bytearray}
        """
        return self._data

    @data.setter
    def data(self, data):
        """
        Sets the data of this MacVerifyRequest.
        The data to verify the MAC of.
        """

        if not isinstance(data, bytearray):
            raise ValueError("Invalid value for `data`, `data` must be a bytearray")
        self._data = data

    @property
    def digest(self):
        """
        Gets the digest of this MacVerifyRequest.
        The MAC previously computed for the input data. NOTE - this field is deprecated. Instead you should use mac field.

        Type: L{bytearray}
        """
        return self._digest

    @digest.setter
    def digest(self, digest):
        """
        Sets the digest of this MacVerifyRequest.
        The MAC previously computed for the input data. NOTE - this field is deprecated. Instead you should use mac field.
        """

        if not isinstance(digest, bytearray):
            raise ValueError("Invalid value for `digest`, `digest` must be a bytearray")
        self._digest = digest

    @property
    def mac(self):
        """
        Gets the mac of this MacVerifyRequest.
        The MAC previously computed for the input data.

        Type: L{bytearray}
        """
        return self._mac

    @mac.setter
    def mac(self, mac):
        """
        Sets the mac of this MacVerifyRequest.
        The MAC previously computed for the input data.
        """

        if not isinstance(mac, bytearray):
            raise ValueError("Invalid value for `mac`, `mac` must be a bytearray")
        self._mac = mac

    def to_dict(self):
        """
        Returns the model properties as a dict
        """
        result = {}

        for attr, _ in iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """
        Returns the string representation of the model
        """
        return pformat(self.to_dict())

    def __repr__(self):
        """
        For `print` and `pprint`
        """
        return self.to_str()

    def __eq__(self, other):
        """
        Returns true if both objects are equal
        """
        if not isinstance(other, MacVerifyRequest):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """
        Returns true if both objects are not equal
        """
        return not self == other

