# coding: utf-8

"""
    Fortanix SDKMS REST API

    This is a set of REST APIs for accessing the Fortanix Self-Defending Key Management System. This includes APIs for managing accounts, and for performing cryptographic and key management operations. 

    OpenAPI spec version: 1.0.0-20200608
    Contact: support@fortanix.com
    Generated by: https://github.com/swagger-api/swagger-codegen.git

    Licensed under the Apache License, Version 2.0 (the "License");
    you may not use this file except in compliance with the License.
    You may obtain a copy of the License at
    
        http://www.apache.org/licenses/LICENSE-2.0
    
    Unless required by applicable law or agreed to in writing, software
    distributed under the License is distributed on an "AS IS" BASIS,
    WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
    See the License for the specific language governing permissions and
    limitations under the License.
"""


from pprint import pformat
from six import iteritems
import re




# NOTE: This class is auto generated by the swagger code generator program.
# Do not edit the class manually.
class RotationPolicy(object):
    """
    @undocumented: swagger_types
    @undocumented: attribute_map
    @undocumented: to_dict
    @undocumented: to_str
    @undocumented: __repr__
    @undocumented: __eq__
    @undocumented: __ne__
    """

    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'interval': 'RotationInterval',
        'effective_at': 'str',
        'deactivate_rotated_key': 'bool'
    }

    attribute_map = {
        'interval': 'interval',
        'effective_at': 'effective_at',
        'deactivate_rotated_key': 'deactivate_rotated_key'
    }

    def __init__(self, interval=None, effective_at=None, deactivate_rotated_key=None):
        """
        RotationPolicy - a model defined in Swagger
        """

        self._interval = None
        self._effective_at = None
        self._deactivate_rotated_key = None

        if interval is not None:
          self.interval = interval
        if effective_at is not None:
          self.effective_at = effective_at
        if deactivate_rotated_key is not None:
          self.deactivate_rotated_key = deactivate_rotated_key

    @property
    def interval(self):
        """
        Gets the interval of this RotationPolicy.

        Type: L{RotationInterval}
        """
        return self._interval

    @interval.setter
    def interval(self, interval):
        """
        Sets the interval of this RotationPolicy.
        """

        self._interval = interval

    @property
    def effective_at(self):
        """
        Gets the effective_at of this RotationPolicy.
        Start time of the rotation policy

        Type: L{str}
        """
        return self._effective_at

    @effective_at.setter
    def effective_at(self, effective_at):
        """
        Sets the effective_at of this RotationPolicy.
        Start time of the rotation policy
        """

        self._effective_at = effective_at

    @property
    def deactivate_rotated_key(self):
        """
        Gets the deactivate_rotated_key of this RotationPolicy.
        Upon key rotation, the old key will automatically be deactivated. This only affects keys that were in the Preactive or Active state.

        Type: L{bool}
        """
        return self._deactivate_rotated_key

    @deactivate_rotated_key.setter
    def deactivate_rotated_key(self, deactivate_rotated_key):
        """
        Sets the deactivate_rotated_key of this RotationPolicy.
        Upon key rotation, the old key will automatically be deactivated. This only affects keys that were in the Preactive or Active state.
        """

        self._deactivate_rotated_key = deactivate_rotated_key

    def to_dict(self):
        """
        Returns the model properties as a dict
        """
        result = {}

        for attr, _ in iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """
        Returns the string representation of the model
        """
        return pformat(self.to_dict())

    def __repr__(self):
        """
        For `print` and `pprint`
        """
        return self.to_str()

    def __eq__(self, other):
        """
        Returns true if both objects are equal
        """
        if not isinstance(other, RotationPolicy):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """
        Returns true if both objects are not equal
        """
        return not self == other

